Loading...
Searching...
No Matches
pcl::GrayStereoMatching Class Referenceabstract

Stereo Matching abstract class for Grayscale images. More...

`#include <pcl/stereo/stereo_matching.h>`

Inheritance diagram for pcl::GrayStereoMatching:

## Public Member Functions

| GrayStereoMatching ()
| ~GrayStereoMatching () override
void | compute (unsigned char *ref_img, unsigned char *trg_img, int width, int height) override
| stereo processing, it computes a disparity map stored internally by the class
void | compute (pcl::PointCloud< pcl::RGB > &ref, pcl::PointCloud< pcl::RGB > &trg) override
| stereo processing, it computes a disparity map stored internally by the class
Public Member Functions inherited from pcl::StereoMatching
| StereoMatching ()
virtual | ~StereoMatching ()
void | setMaxDisparity (int max_disp)
| setter for number of disparity candidates (disparity range)
void | setXOffset (int x_off)
| setter for horizontal offset, i.e.
void | setRatioFilter (int ratio_filter)
| setter for the value of the ratio filter
void | setPeakFilter (int peak_filter)
| setter for the value of the peak filter
void | setPreProcessing (bool is_pre_proc)
| setter for the pre processing step
void | setLeftRightCheck (bool is_lr_check)
| setter for the left-right consistency check stage, that eliminates inconsistent/wrong disparity values from the disparity map at approx.
void | setLeftRightCheckThreshold (int lr_check_th)
| setter for the left-right consistency check threshold
void | medianFilter (int radius)
| median filter applied on the previously computed disparity map
virtual bool | getPointCloud (float u_c, float v_c, float focal, float baseline, pcl::PointCloud< pcl::PointXYZ >::Ptr cloud)
| computation of the 3D point cloud from the previously computed disparity map without color information
virtual bool | getPointCloud (float u_c, float v_c, float focal, float baseline, pcl::PointCloud< pcl::PointXYZRGB >::Ptr cloud, pcl::PointCloud< pcl::RGB >::Ptr texture)
| computation of the 3D point cloud from the previously computed disparity map including color information
void | getVisualMap (pcl::PointCloud< pcl::RGB >::Ptr vMap)
| computation of a pcl::RGB cloud with scaled disparity values it can be used to display a rescaled version of the disparity map by means of the pcl::ImageViewer invalid disparity values are shown in green

## Protected Member Functions

void | compute_impl (unsigned char *ref_img, unsigned char *trg_img) override=0
void | preProcessing (unsigned char *img, unsigned char *pp_img) override
void | imgFlip (unsigned char *&img) override
Protected Member Functions inherited from pcl::StereoMatching
void | leftRightCheck ()
short int | computeStereoSubpixel (int dbest, int s1, int s2, int s3)
short int | computeStereoSubpixel (int dbest, float s1, float s2, float s3)

## Additional Inherited Members

Protected Attributes inherited from pcl::StereoMatching
short int * | disp_map_
| The internal disparity map.
unsigned char * | ref_img_
| Local aligned copies of the cloud data.
unsigned char * | trg_img_
short int * | disp_map_trg_
| Disparity map used for left-right check.
unsigned char * | pp_ref_img_
| Local aligned copies used for pre processing.
unsigned char * | pp_trg_img_
int | width_
| number of pixels per column of the input stereo pair .
int | height_
| number of pixels per row of the input stereo pair .
int | max_disp_
| Disparity range used for stereo processing.
int | x_off_
| Horizontal displacemente (x offset) used for stereo processing.
int | ratio_filter_
| Threshold for the ratio filter, .
int | peak_filter_
| Threshold for the peak filter, .
bool | is_pre_proc_
| toggle for the activation of the pre-processing stage
bool | is_lr_check_
| toggle for the activation of the left-right consistency check stage
int | lr_check_th_
| Threshold for the left-right consistency check, typically either 0 or 1.

## Detailed Description

Stereo Matching abstract class for Grayscale images.

The class implements some functionalities of pcl::StereoMatching specific for grayscale stereo processing, such as image pre-processing and left

Author
  Federico Tombari (feder.nosp@m.ico..nosp@m.tomba.nosp@m.ri@u.nosp@m.nibo..nosp@m.it)

Definition at line 371 of file stereo_matching.h.

## Constructor & Destructor Documentation

## GrayStereoMatching()

pcl::GrayStereoMatching::GrayStereoMatching | ( |  | ) |

## ~GrayStereoMatching()

pcl::GrayStereoMatching::~GrayStereoMatching | ( |  | ) |

override

## Member Function Documentation

## compute() [1/2]

void pcl::GrayStereoMatching::compute | ( | pcl::PointCloud< pcl::RGB > & | ref,
|  | pcl::PointCloud< pcl::RGB > & | trg )

override virtual

stereo processing, it computes a disparity map stored internally by the class

Parameters

  [in] | ref | point cloud of pcl::RGB type containing the pixels of the reference image (left image) the pcl::RGB triplets are automatically converted to grayscale upon call of the method
  [in] | trg | point cloud of pcl::RGB type containing the pixels of the target image (right image) the pcl::RGB triplets are automatically converted to grayscale upon call of the method

Implements pcl::StereoMatching.

## compute() [2/2]

void pcl::GrayStereoMatching::compute | ( | unsigned char * | ref_img,
|  | unsigned char * | trg_img,
|  | int | width,
|  | int | height )

override virtual

stereo processing, it computes a disparity map stored internally by the class

Parameters

  [in] | ref_img | reference array of image pixels (left image), has to be grayscale single channel
  [in] | trg_img | target array of image pixels (right image), has to be grayscale single channel
  [in] | width | number of elements per row for both input arrays
  [in] | height | number of elements per column for both input arrays

Implements pcl::StereoMatching.

## compute_impl()

void pcl::GrayStereoMatching::compute_impl | ( | unsigned char * | ref_img,
|  | unsigned char * | trg_img )

override protected pure virtual

Implements pcl::StereoMatching.

## imgFlip()

void pcl::GrayStereoMatching::imgFlip | ( | unsigned char *& | img | ) |

override protected virtual

Implements pcl::StereoMatching.

## preProcessing()

void pcl::GrayStereoMatching::preProcessing | ( | unsigned char * | img,
|  | unsigned char * | pp_img )

override protected virtual

Implements pcl::StereoMatching.

The documentation for this class was generated from the following file:

- pcl/stereo/stereo_matching.h